<?php

	class wialon_hosting {
		public $sid = "";
		public $id_user_session = "";
		public $id_resource_session = "";
		public $id_tp_session = "";
	   
		public $dns = "";
		public $login_name = "";
		public $login_pass = "";
		private $log = "";
		
		public $debug_mode = "1";
		
		private $array_coord = "";
		private $ind_coord = 0;
		
		function __construct($log,$dns,$login,$pass) {
			if ($log == "" ) {
				$this->log = new logs("trace");
			} else {
				$this->log = new logs($log);
			}
			
			if ($dns == "") {
				$this->log->trace("Error initialize object class wialon_hosting: dns=$dns, login=$login, pass=$pass");
				return;
			}
			
			$this->dns = $dns;
			$this->login_name = $login;
			$this->login_pass = $pass;				
			
			if ($this->login_name != "")
			    $this->login();	
		}
		
		// login
		function login() 
		{	
			if ($this->debug_mode == "1")
				$this->log->trace("Attempt login to wialon hosting" . $this->dns . ", login=" . $this->login_name);
				
			$result_login = $this->wialon_request("core/login","{\"user\":\"" . $this->login_name . "\", \"password\":\"" . $this->login_pass . "\"}");
			if ($result_login == "error") {
				$this->log->trace("Error login to wialon hosting " . $this->dns . ", login=" . $this->login_name);
				return;
			}
			$this->sid = $result_login -> {'eid'};
			$this->id_user_session = $result_login ->{'user'} -> {'id'};	
			$this->id_resource_session = $result_login->{'user'}->{'bact'};	
			
			if ($this->debug_mode == "1")
				$this->log->trace("Login to wialon hosting (sid: " . $this->sid . ")");
				
			if ($this->id_resource_session != "") {
			
				$lang = "ru";
				if (isset($result_login->{'user'}->{'prp'}->{'language'}))
					$lang = $result_login->{'user'}->{'prp'}->{'language'};
				// localisation
				$this->wialon_request("render/set_locale",'{"tzOffset":' . $result_login->{'user'}->{'prp'}->{'tz'} . ',"language":"' . $lang . '"}');
			
				$account = $this->wialon_request("core/get_account_data",'{"type":1}');
				if ($account != "error" &&  isset($account->{'plan'}))	{
					$letters = array('.', '-', ' ');
					$replace_letter   = array('_', '_','_');
					$this->id_tp_session = str_replace($letters, $replace_letter, $account->{'plan'});
					
					if ($this->debug_mode == "1")
						$this->log->trace("Good get account info (TP: " . $this->id_tp_session . ")");
				}
				
				if (isset($result_login->{'user'}->{'prp'}->{'trackingm_logo'}))
					$this->id_tp_session = $result_login->{'user'}->{'prp'}->{'trackingm_logo'};
				
			}
						
		}
		// logout
		function logout() 
		{
			if ($this->sid == "")
				return "error";
			
			if ($this->debug_mode == "1")			
				$this->log->trace("Logout wialon hosting (sid: " . $this->sid . ")");
			$this->wialon_request("core/logout","{}");
			$this->sid = "";
			$this->id_user_session = "";
		}
		// request to wialon with socket
		function wialon_request($svc,$params,$now_decode=0) 
		{
			$fp = fsockopen($this->dns, 80, $errno, $errstr, 60);
			if (!$fp) {
				$this->log->trace("error wialon_request: $errstr ($errno)");
				return;
			} 
			
			if ($this->sid != "")
				$data = "svc=" . $svc . "&sid=" . $this->sid . "&params=" . $params . "\r\n";
			else 
				$data = "svc=" . $svc . "&params=" . $params . "\r\n";
			
			if ($this->debug_mode == "1") {
				$this->log->trace("request: " . $data);
			}
			
			$out = "POST /wialon/ajax.html HTTP/1.0\r\n";
			$out .= "Host: " . $this->dns . "\r\n";
			$out .= "Content-type: application/x-www-form-urlencoded\r\n";
			$out .= "Content-length: ".strlen($data)."\r\n";
			$out .= "Connection: Close\r\n\r\n";
			$out .= $data."\r\n\r\n";
			
			$html = '';
			
			fwrite($fp, $out);
			while (!feof($fp)) {
				$html .= fgets($fp, 128);
			}
			fclose($fp);
			
			$pos = strpos($html, "\r\n\r\n");
			if ($pos > 0) {
				$html = substr($html, $pos+4);
			}

			if ($this->debug_mode == "1") {
				$this->log->trace("answer: " . $html);
			}
			if ($now_decode == 1) 
				$json = $html;
			else {
				$json = json_decode($html);
				if (isset($json->{'error'}) && $json->{'error'} != "") {
					$this->log->trace("Errro request to Wialon (sid: " . $this->sid . ") : " . $html);
					return "error";
				}
			}
			return $json;
		}
				
		// get units array
		function get_items($type,$flags)
		{
			$params = '{"spec":{"itemsType":"' . $type . '","propName":"sys_name","propValueMask":"*","sortType":"sys_name"},"force":1,"flags":' . $flags . ',"from":0,"to":"0xffffffff"}';
			$items = $this->wialon_request("core/search_items",$params);
			
			if (isset($items->{'items'}))
			      return $items -> {'items'};
			else
			      return ""; 
		}
		
		// check sid
		function check_sid()
		{
			$params = '{"spec":{"itemsType":"avl_unit","propName":"sys_name","propValueMask":"*","sortType":"sys_name"},"force":1,"flags":0x1,"from":0,"to":"0xffffffff"}';
			if ($this->wialon_request("core/search_items",$params) == "error")
				return "false";
			else
				return "true";
		}
		
		// serach items from id
		function search_items_from_id($items,$id)
		{
			if($items != "")
			foreach($items as $item) {
				$name_item = $item->{'nm'};
				$id_item = $item->{'uid'};
				
				if ($id_item == $id) 
					return $item;
				
			}
			return "";
		}
	} 

?>
