	/// Global event handlers
	var callbacks = {};
	var curr_user_session = "";
	var session = "";
	var list_users = "";
	var list_units = "";
	var list_group_units = "";
	var list_hw_types = "";
	
	/// IE check
	function ie() {
		return (navigator.appVersion.indexOf("MSIE 6") != -1 || navigator.appVersion.indexOf("MSIE 7") != -1 || navigator.appVersion.indexOf("MSIE 8") != -1);
	}
	/// Execute callback
	function exec_callback(id) {
		// console.log("exec_callback: " + id);
		if (!callbacks[id])
			return;
		callbacks[id].call();
	}
	/// Wrap callback
	function wrap_callback(callback) {
		var id = (new Date()).getTime();
		callbacks[id] = callback;
		return id;
	}
	/// Fetch varable from 'GET' request
	function get_html_var(name) {
		if (!name)
			return null;
		var pairs = decodeURIComponent(document.location.search.substr(1)).split("&");
		for (var i = 0; i < pairs.length; i++) {
			var pair = pairs[i].split("=");
			if (pair[0] == name) {
				pair.splice(0, 1);
				return pair.join("=");
			}
		}
		return null;
	}
	/// Load script
	function load_script(src, callback) {
		var script = document.createElement("script");
		script.setAttribute("type","text/javascript");
		script.setAttribute("charset","UTF-8");
		script.setAttribute("src", src);
		if (callback && typeof callback == "function") {
			var id = wrap_callback(callback);
			if (ie())
				script.onreadystatechange = function () {
					if (this.readyState == 'complete' || this.readyState == 'loaded')
						callback();
				}
			else
				script.setAttribute("onLoad", "exec_callback(" + wrap_callback(callback) + ")");
		}
		document.getElementsByTagName("head")[0].appendChild(script);
	}
	/// Login result
	function login(code) {
		if (code) {
			alert("Login error");
			return;
		}	
		generate_page();
	}
	/// Init SDK
	function init_sdk() {
		var url = get_html_var("baseUrl");
		if (!url)
			url = get_html_var("hostUrl");
		if (!url)
			return;
		wialon.core.Session.getInstance().initSession(url);
		wialon.core.Session.getInstance().duplicate(get_html_var("sid"), "", true, login);
	}
	/// We are ready now
	window.onload = function() {
		var url = get_html_var("baseUrl");
		if (!url)
			url = get_html_var("hostUrl")
		if (!url)
			return;
		url += "/wsdk/script/wialon.js" ;

		load_script(url, init_sdk);
		// TODO:
	}
	
	function get_user_by_name(name) {		
		// load list cmd
		for (var i = 0; i < list_users.length; i++) {
			var user = list_users[i];
			var user_name = user.getName();	
			if (name == user_name) 
				return user;
		}
		return "NULL";
	}
	function get_user_by_id(id) {		
		// load list cmd
		for (var i = 0; i < list_users.length; i++) {
			var user = list_users[i];
			var user_name = user.getId();	
			if (id == user_name) 
				return user;
		}
		return "NULL";
	}
	function get_unit_by_id(id) {
		// load list cmd
		for (var i = 0; i < list_units.length; i++) {
			var unit = list_units[i];
			var unit_id = unit.getId();
			
			if (id == unit_id) 
				return unit;
		}
		return "NULL";
	}
	
	function get_hw_type_by_id(id) {
		// load list cmd
		for (var i = 0; i < list_hw_types.length; i++) {
			var hw = list_hw_types[i];
					
			if (id == hw.id) 
				return hw.name;
		}
		return "";
	}
	
	function get_group_units_by_id(id) {
		// load list cmd
		for (var i = 0; i < list_group_units.length; i++) {
			var unit = list_group_units[i];
			var unit_id = unit.getId();
			
			if (id == unit_id) 
				return unit;
		}
		return "NULL";
	}

	function show_hide_block(id_block) {
		var plugin_div = jQuery("#" + id_block);
		if (plugin_div.css("display") == "none") {
			plugin_div.show();
			return true;
		} else {
			plugin_div.hide();
			return false;
		}
	}

	function generate_page_units() {
		session = wialon.core.Session.getInstance(); // get instance of current Session
		curr_user_session = wialon.core.Session.getInstance().getCurrUser();
		
		jQuery("#login").append("<b>" + curr_user_session.getName() + "</b>");
			
		$("#process").html("<img src='img/load.gif'/><div id='percent_process'></div>");
		
		// get list uers
		var dataFlags = wialon.item.Item.dataFlag.base | wialon.item.Item.dataFlag.customProps  | wialon.item.User.dataFlag.connSettings | wialon.item.User.dataFlag.flags |wialon.item.Item.accessFlag.editOther ;
		var spec = [{type: "type", data: "user", flags: dataFlags, mode: 0}];
		session.updateDataFlags(spec, function(code) {
			if (code) { msg(wialon.core.Errors.getErrorText(code)); return; }
			list_users = session.getItems("user");		
		
			// get list units
			// init wialon event system
			var spec = [{type: "type", data: "avl_unit", flags: dataFlags, mode: 0}];
			session.updateDataFlags(spec, function(code) {
				if(code) {
					alert("updateDataFlags error: ["+ code +"] " + wialon.core.Errors.getErrorText(code));
					return;
				}
				
				// load units
				list_units = session.getItems("avl_unit");
				
				///////// get unit group ////////////
				var searchSpec = {
					itemsType: "avl_unit_group",            // item type
					propName: "sys_name",             // search by name
					propValueMask: "*",               // any match
					sortType: "sys_name"              // sort by name
				}; 
				// flags for getting report templates
				var dataFlags = wialon.item.Item.dataFlag.base|wialon.item.Resource.dataFlag.reports;
				// search...
				session.searchItems(searchSpec, true, dataFlags, 0, 0, qx.lang.Function.bind(function(code, data) {
					if (code) {
						alert(wialon.core.Errors.getErrorText(code));
						return;
					}
					// populate resources list
					list_group_units = data.items;
				
					session.getHwTypes(function(code, data) {
						if (code) {
							alert(wialon.core.Errors.getErrorText(code));
							return;
						}
						// populate resources list
						list_hw_types = data;
						
						show_list_units();		
					});
					
					
				}, this));
				
			}, this);								
		}, this);				
	
	}
	
	function show_list_units() {
		// load list units
		for (var i = 0; i < list_units.length; i++) {
			var unit = list_units[i];
			$("#units").append("<tr id='tr_" + i + "'><td>" + (i+1) + "</td><td id='td_name_" + i + "'>" + unit.getName() + "</td><td id='td_id_" + i + "'>" + unit.getUniqueId() + "</td><td id='td_type_" + i + "'>" + get_hw_type_by_id(unit.getDeviceTypeId()) + "</td><td id='td_phone_" + i + "'>" + unit.getPhoneNumber() + "</td><td id='td_user_" + i + "'><div id='div_access_unit_" + unit.getId()  + "'></div></td></tr>");
		}		
		show_list_users();
	}
	
	
	
	var active_index = 0;
	
	// print list accounts
	function show_list_users() {
	
		if (active_index % 10 == 0)
			$("#percent_process").html("<b>" + (active_index * 100/list_users.length).toFixed(0)  + " %" + "</b>");
	
	
		if (active_index >= list_users.length) {
			$("#process").html("");
			return;
		}
		var user = list_users[active_index];	
		if (user.getName() == curr_user_session.getName()) {
			active_index++;
			show_list_users();
			return;
		}
		
		user.getItemsAccess(true, "avl_unit", function(code,result) {
			if (code) { alert(wialon.core.Errors.getErrorText(code)); return; }
			for(var unit_id in result)
				$("#div_access_unit_" + unit_id).append(user.getName() + ", ");
			
			
			user.getItemsAccess(true, "avl_unit_group", function(code,result) {
				if (code) { alert(wialon.core.Errors.getErrorText(code)); return; }
				for(var group_id in result) {
					var group = get_group_units_by_id(group_id);
					if (group != "NULL") {
						var units = group.getUnits();
						for (var i = 0; i < units.length; i++) {
							var unit_id = units[i];
							var str = $("#div_access_unit_" + unit_id).html();
							if (str.indexOf(user.getName()) == -1)
								$("#div_access_unit_" + unit_id).append(user.getName() + ", ");
						}
					}
				}
				
				active_index++;
				show_list_users();
			
			});			
		});
	}
	
	// show/hide html block
	function show_hide_block(id_block) {
		var plugin_div = jQuery("#" + id_block);
		if (plugin_div.css("display") == "none") {
			plugin_div.show();
			return true;
		} else {
			plugin_div.hide();
			return false;
		}
	}
	
	function filtr() {
		var name = $("#filtr_name").val();
		var id = $("#filtr_id").val();
		var type = $("#filtr_type").val();
		var phone = $("#filtr_phone").val();
		var user = $("#filtr_user").val();
		
		
		if (active_index < list_users.length) {
			alert("      .");
			return;
		}
		
		$("#process").html("");
		
		for (var i = 0; i < list_units.length; i++) {	
			$("#tr_" + i).show();
			
			if (name != "" && name != "*") {
				var str = $("#td_name_" + i).html();
				if(str.indexOf(name) < 0) 
					$("#tr_" + i).hide();
			}
			
			if (id != "" && id != "*") {
				if($("#td_id_" + i).html() != id) 
					$("#tr_" + i).hide();
			}
			
			if (type != "" && type != "*") {
				var str = $("#td_type_" + i).html();
				if(str.indexOf(type) < 0) 
					$("#tr_" + i).hide();
			}
			
			if (phone != "" && phone != "*") {
				if($("#td_phone_" + i).html() != phone) 
					$("#tr_" + i).hide();
			}
			
			if (user != "" && user != "*") {
				var str = $("#td_user_" + i).html();
				if(str.indexOf(user) < 0) 
					$("#tr_" + i).hide();
			}
		}
	}
